
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class OScope extends JFrame implements ActionListener, ChangeListener{ 
	    
    boolean sol=false;
    double x1=250,y1=210;
    double escalaX=1,escalaY=1;
    private JButton plusVolt; //+voltage
    private JButton minusVolt;//-votage
    private JButton plusTime;//+tiempo
    private JButton minusTime;//-tiempo
    private JButton solucion;//solucion
    private JButton nosolucion;
    private JLabel preambulo,sfd,datos,crc;
    private JSlider xslider, yslider;//barras para mover el ejee Y y el X
    private int xOffset, yOffset;
    private Color color=Color.yellow;
    private TextField tVolt, tTime;//, tFreq, tAmp;//zonas de texto
    Image back,image;
    private JLabel background;
    private JLayeredPane pane;
    Container cp;
    int vPointer = 1;
    int value;
    int tPointer = 3;
    int resolXslider[]= {15000,30000,40000,150000};
    int indiceXslider=0;
    double volt[] = {0.6,0.3,0.15,0.075};
    double time[] = {2.5,5,10,20,40,80};
    int ping[];
    Practica3_ping applet;
    
    public OScope(Practica3_ping ap,int [] p){ 	
        
        Font f = new Font("Arial",Font.PLAIN,14);
        Font f1 = new Font("Arial",Font.PLAIN,11);

        applet=ap;
        this.setResizable(false);
        pane = new JLayeredPane();
        pane.setBackground(Color.white);
        setBackground(Color.white);
        setSize(850,500);
        pane.setLayout(null);

        xslider = new JSlider(-15000,15000,0);
        xslider.setBounds(130,350,250,25);
        xslider.setVisible(true);
        xslider.setOpaque(false);
        xslider.addChangeListener(this);

        yslider = new JSlider(JSlider.VERTICAL,-300,300,0);
        yslider.setBounds(460,90,25,250);
        yslider.setVisible(true);
        yslider.setOpaque(false);
        yslider.addChangeListener(this);

        pane.add(xslider);
        pane.add(yslider);
        setVisible(true);

        plusVolt = new JButton("+");
        plusVolt.setFont(f);
        plusVolt.setBounds(560,80,60,25);
        pane.add(plusVolt);
        plusVolt.addActionListener(this);

        minusVolt = new JButton("-");
        minusVolt.setFont(f);
        minusVolt.setBounds(625,80,60,25);
        pane.add(minusVolt);
        minusVolt.addActionListener(this);

        plusTime = new JButton("+");
        plusTime.setFont(f);
        plusTime.setBounds(560,155,60,25);
        pane.add(plusTime);
        plusTime.addActionListener(this);

        minusTime = new JButton("-");
        minusTime.setFont(f);
        minusTime.setBounds(625,155,60,25);
        pane.add(minusTime);
        minusTime.addActionListener(this);
            
        solucion = new JButton("Pulsar para ver solucion");
        solucion.setFont(f1);
        solucion.setBounds(555,280,200,25);
        pane.add(solucion);
        solucion.addActionListener(this);
            
        nosolucion = new JButton("Pulsar para ocultar solucion");
        nosolucion.setFont(f1);
        nosolucion.setBounds(555,280,200,25);
        pane.add(nosolucion);
        nosolucion.setVisible(false);
        nosolucion.addActionListener(this);

        preambulo=new JLabel("PREAMBULO");
        preambulo.setBounds(610,280,200,100);
        preambulo.setForeground(Color.ORANGE);
        pane.add(preambulo);
        preambulo.setVisible(false);

        sfd=new JLabel("SFD");
        sfd.setBounds(610,300,200,100);
        sfd.setForeground(Color.RED);
        pane.add(sfd);
        sfd.setVisible(false);
            
        datos=new JLabel("DATOS");
        datos.setBounds(610,320,200,100);
        datos.setForeground(Color.BLUE);
        pane.add(datos);
        datos.setVisible(false);

        crc=new JLabel("CRC");
        crc.setBounds(610,340,200,100);
        crc.setForeground(Color.PINK.darker());
        pane.add(crc);
        crc.setVisible(false);
            
        tVolt = new TextField();
        tVolt.setFont(new java.awt.Font("Tahoma", 0, 14));
        tVolt.setEditable(false);
        tVolt.setBounds(690,80,60,25);
        pane.add(tVolt);
        tVolt.setText(getVolt());

        tTime = new TextField();
        tTime.setFont(new java.awt.Font("Tahoma", 0, 14));
        tTime.setEditable(false);
        tTime.setBounds(690,155,60,25);
        pane.add(tTime);
        tTime.setText(getTime());
            
        super.setIconImage(applet.getImage("logoUpct_1.png"));
        setTitle("Osciloscopio");
        ping=p;
        back=applet.getImage("osc2.gif");
        ImageIcon bgicon = new ImageIcon(back);
        background = new JLabel(bgicon);
        background.setOpaque(true);
        background.setBounds(0,0,bgicon.getIconWidth(), bgicon.getIconHeight());

        pane.add(background,new Integer(0));
        getContentPane().setBackground(Color.white);
        getContentPane().add(pane);
        
        this.repaint();
       
    }
	
    public void stateChanged(ChangeEvent e){
    
        JSlider source = (JSlider)e.getSource();
        
        if (source==yslider){
            yOffset =(-1)* (int)source.getValue();
            repaint();
        }
        else if(source==xslider){
           xOffset = (-1)*(int)source.getValue();
           repaint();
        }
     }
        
    public void paint(Graphics g){

        super.paint(g);
        int gridSize = 400;			 
        int ygridSize = 320;
        int border = 50;		     
        int gb = gridSize+border;
        int inc = (gridSize/10) / 5; // length between increments

	//-- Draws the Grid ----------------------------------------------------------

        g.setColor((Color.green).darker());

        for(int x=border;x<=gb;x+=gridSize/10)      // draws major x and y axes
                g.drawLine(x,border,x,ygridSize+border);

        for(int y=border;y<=(ygridSize+border);y+=gridSize/10)
                g.drawLine(border,y,gb,y);

        g. setColor(Color.white);
        for(int xi=border;xi<=gb;xi+=inc)   				// draws increments
                g.drawLine(xi,ygridSize/2-5+border,xi,ygridSize/2+5+border);

        for(int yi=border;yi<=(ygridSize+border);yi+=inc)
                g.drawLine(gridSize/2-5+border,yi,gridSize/2+5+border,yi);

        g.drawLine(250,50,250,370);
        g.drawLine(50,210,450,210);

	//-- Draws ping -----------------------------------------------------

        g.setColor(color);

        if(sol){
           g.setColor(Color.ORANGE); 
        }
                
        int xo=(int)(x1+xOffset);
        int yo=(int)(y1+yOffset);
        int dx=(int)(20*escalaX),dy=(int)(40*escalaY),anchoPing=(int)(40*escalaX);
        if(xo>=50-xOffset&&xo+anchoPing<=450-xOffset){//dentro del marco segun x
            if(yo-dy>=50-yOffset&&yo<370-yOffset){//dentro del marco segun y
                if(ping[0]==1){
                    g.drawLine(xo+xOffset,yo+yOffset,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset,yo+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset, yo-dy+yOffset, xo+2*dx+xOffset,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                        g.drawLine(xo+xOffset,yo+yOffset,xo+xOffset,yo-dy+yOffset);
                        g.drawLine(xo+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                        g.drawLine(xo+dx+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo+yOffset);
                        g.drawLine(xo+dx+xOffset, yo+yOffset, xo+2*dx+xOffset,yo+yOffset);
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                }
             }
             else if(yo-dy<50-yOffset&&yo-dy>=50-yOffset-dy){//dentro segun x pero se sale por arriba
                 if(ping[0]==1){
                        g.drawLine(xo+xOffset,yo+yOffset,xo+dx+xOffset,yo+yOffset);
                        g.drawLine(xo+dx+xOffset,yo+yOffset,xo+dx+xOffset,50);
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
                 else{
                        g.drawLine(xo+xOffset,yo+yOffset,xo+xOffset,50);//esta
                        g.drawLine(xo+dx+xOffset,50,xo+dx+xOffset,yo+yOffset);
                        g.drawLine(xo+dx+xOffset, yo+yOffset, xo+2*dx+xOffset,yo+yOffset);
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                 }
             }
             else if(yo>=370-yOffset&&yo<=370-yOffset+dy){//dentro segun x pero se sale por abajo
               if(ping[0]==1){
                        g.drawLine(xo+dx+xOffset,370,xo+dx+xOffset,yo-dy+yOffset);
                        g.drawLine(xo+dx+xOffset, yo-dy+yOffset, xo+2*dx+xOffset,yo-dy+yOffset);
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
               else{
                        g.drawLine(xo+xOffset,370,xo+xOffset,yo-dy+yOffset);//esta
                        g.drawLine(xo+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                        g.drawLine(xo+dx+xOffset,yo-dy+yOffset,xo+dx+xOffset,370);
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
               }
             }
             else if(yo-dy<=50-yOffset-dy||yo>=370-yOffset+dy){// el primer bit esta totalmente fuera ya sea que ha salido por arriba o por abajo
                 if(ping[0]==1){
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
                 else{
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                 }
             }
         }
         else if((xo<50-xOffset&&xo>=(50-xOffset-dx))){//se empieza a salir la primera mitad del primer bit
             if(yo-dy>=50-yOffset&&yo<370-yOffset){// esta dentro segun y
                if(ping[0]==1){
                    g.drawLine(50,yo+yOffset,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset,yo+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset, yo-dy+yOffset, xo+2*dx+xOffset,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                    g.drawLine(50,yo-dy+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset, yo+yOffset, xo+2*dx+xOffset,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo+yOffset;
                }
             }
             else if(yo-dy<50-yOffset&&yo-dy>=50-yOffset-dy){// se sale por arriba segun y
                 if(ping[0]==1){
                    g.drawLine(50,yo+yOffset,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset,yo+yOffset,xo+dx+xOffset,50);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                    g.drawLine(xo+dx+xOffset,50,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset, yo+yOffset, xo+2*dx+xOffset,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo+yOffset;
                }
             }
             else if(yo>=370-yOffset&&yo<=370-yOffset+dy){// se sale por abajo segun y
               if(ping[0]==1){
                    g.drawLine(xo+dx+xOffset,370,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset, yo-dy+yOffset, xo+2*dx+xOffset,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                    g.drawLine(50,yo-dy+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset,yo-dy+yOffset,xo+dx+xOffset,370);
                    xo=xo+2*dx+xOffset;
                    yo=yo+yOffset;
                }
             }
             else {// se sale totalmente por arriba o por abajo
                 if(ping[0]==1){
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
                else{
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                }
             }
         }
         else if(xo<(50-xOffset-dx)&&xo>(50-xOffset-2*dx)){//se sale la segunda parte del del primer bit por la izquierda
             if(yo-dy>=50-yOffset&&yo<370-yOffset){//esta dentro segun x
                if(ping[0]==1){
                    g.drawLine(50, yo-dy+yOffset,xo+2*dx+xOffset,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                    g.drawLine(50, yo+yOffset,xo+2*dx+xOffset,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo+yOffset;
                }
             }
             else if(yo-dy<50-yOffset&&yo-dy>=50-yOffset-dy){//se sale por arriba
                 if(ping[0]==1){
                }
                else{
                    g.drawLine(50, yo+yOffset,xo+2*dx+xOffset,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo+yOffset;
                }
             }
             else{//esta totalmete fuera por arriba o por abajo
                 if(ping[0]==1){
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
                else{
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                }
             }
         }
         else if((xo+anchoPing>450-xOffset&&xo+anchoPing<=450-xOffset+dx)){//se sale la segunda parte del primer bit por la derecha
             if(yo-dy>=50-yOffset&&yo<370-yOffset){//dentro segun y
                if(ping[0]==1){
                    g.drawLine(xo+xOffset,yo+yOffset,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset,yo+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset, yo-dy+yOffset, 450,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                   g.drawLine(xo+xOffset,yo+yOffset,xo+xOffset,yo-dy+yOffset);//esta 
                   g.drawLine(xo+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                   g.drawLine(xo+dx+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo+yOffset);
                   g.drawLine(xo+dx+xOffset, yo+yOffset, 450,yo+yOffset);
                   xo=xo+2*dx+xOffset;
                   yo=yo+yOffset;
                }
             }
             else if(yo-dy<50-yOffset&&yo-dy>=50-yOffset-dy){// se sale por arriba
                 if(ping[0]==1){
                    g.drawLine(xo+xOffset,yo+yOffset,xo+dx+xOffset,yo+yOffset);
                    g.drawLine(xo+dx+xOffset,yo+yOffset,xo+dx+xOffset,50);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                   g.drawLine(xo+xOffset,yo+yOffset,xo+xOffset,50);//esta  
                   g.drawLine(xo+dx+xOffset,50,xo+dx+xOffset,yo+yOffset);
                   g.drawLine(xo+dx+xOffset, yo+yOffset, 450,yo+yOffset);
                   xo=xo+2*dx+xOffset;
                   yo=yo+yOffset;
                }
             }
             else if(yo>=370-yOffset&&yo<=370-yOffset+dy){//se sale por abajo
                 if(ping[0]==1){
                    g.drawLine(xo+dx+xOffset,370,xo+dx+xOffset,yo-dy+yOffset);
                    g.drawLine(xo+dx+xOffset, yo-dy+yOffset, 450,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                   g.drawLine(xo+xOffset,370,xo+xOffset,yo-dy+yOffset);//esta
                   g.drawLine(xo+xOffset,yo-dy+yOffset,xo+dx+xOffset,yo-dy+yOffset);
                   g.drawLine(xo+dx+xOffset,yo-dy+yOffset,xo+dx+xOffset,370);
                   xo=xo+2*dx+xOffset;
                   yo=yo+yOffset;
                }
             }
             else {//total mente fuera por arriba o por abajo
                 if(ping[0]==1){
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
                else{
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                }
             }
         }
         else if((xo+anchoPing>450-xOffset+dx&&xo+anchoPing<=450-xOffset+2*dx)){// se sale la primera parte del primer bit por la derecha
             if(yo-dy>=50-yOffset&&yo<370-yOffset){//dentro segun y
                if(ping[0]==1){
                    g.drawLine(xo+xOffset,yo+yOffset,450,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                    g.drawLine(xo+xOffset,yo+yOffset,xo+xOffset,yo-dy+yOffset);//esta
                    g.drawLine(xo+xOffset,yo-dy+yOffset,450,yo-dy+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo+yOffset;
                }
             }
             else if(yo-dy<50-yOffset&&yo-dy>=50-yOffset-dy){//se sale por arriba
                 if(ping[0]==1){
                    g.drawLine(xo+xOffset,yo+yOffset,450,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                   g.drawLine(xo+xOffset,yo+yOffset,xo+xOffset,50);//esta
                   xo=xo+2*dx+xOffset;
                   yo=yo+yOffset;
                }
             }
             else if(yo>=370-yOffset&&yo<=370-yOffset+dy){//se sale por abajo
                 if(ping[0]==1){
                   g.drawLine(xo+xOffset,yo+yOffset,450,yo+yOffset);
                    xo=xo+2*dx+xOffset;
                    yo=yo-dy+yOffset;
                }
                else{
                   g.drawLine(xo+xOffset,370,xo+xOffset,yo-dy+yOffset);//esta
                   g.drawLine(xo+xOffset,yo-dy+yOffset,450,yo-dy+yOffset);  
                   xo=xo+2*dx+xOffset;
                   yo=yo+yOffset;
                }
             }
             else{// totalemente fuera por abajo o por arriba
                 if(ping[0]==1){
                        xo=xo+2*dx+xOffset;
                        yo=yo-dy+yOffset;
                    }
                else{
                        xo=xo+2*dx+xOffset;
                        yo=yo+yOffset;
                }
             }
         }
         else{//totalmente fuera segun x e y
             xo=xo+2*dx+xOffset;
             if(ping[0]==1){
                 yo=yo-dy+yOffset;
             }
             else{
                 yo=yo+yOffset;
             }
         }
         for(int i=1; i<ping.length;i++){
             if(sol){
                 if(i<56){
                     g.setColor(Color.ORANGE);
                 }
                 else if(i>=56&&i<64){
                     g.setColor(Color.RED);
                 }
                 else if(i>=ping.length-32){//////////////////////////////////////////acabo de modificarlo
                     g.setColor(Color.PINK);
                 }
                 else{
                     g.setColor(Color.BLUE);
                 }
             }
            if(ping[i]==1&ping[i-1]==1){
                if(xo>=50&&xo+anchoPing<=450){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(xo,yo,xo,yo+dy);
                        g.drawLine(xo,yo+dy,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo,xo+2*dx,yo+dy);
                        }
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(xo,50,xo,yo+dy);
                        g.drawLine(xo,yo+dy,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+dx,50);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,50,xo+2*dx,yo+dy);
                        }
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo,yo,xo,370);
                        g.drawLine(xo+dx, 370, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo,xo+2*dx,370);
                        }
                    }
                    else if(yo<=50-dy||yo+dy>=370+dy) {

                     }
                }
                else if(xo<50&&xo>=(50-dx)){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(50,yo+dy,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo,xo+2*dx,yo+dy);
                        }
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(50,yo+dy,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+dx,50);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,50,xo+2*dx,yo+dy);
                        }
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo+dx, 370, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo,xo+2*dx,370);
                        }
                    }
                    else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo<(50-dx)&xo>=50-2*dx){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(50, yo, xo+2*dx,yo);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo,xo+2*dx,yo+dy);
                        }
                    }
                    else if(yo<50&&yo>50-dy){
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,50,xo+2*dx,yo+dy);
                        }
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(50, yo, xo+2*dx,yo);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo,xo+2*dx,370);
                        }
                    }
                    else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo+anchoPing>450&&xo+anchoPing<=(450+dx)){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(xo,yo,xo,yo+dy);
                        g.drawLine(xo,yo+dy,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+dx,yo);
                        g.drawLine(xo+dx, yo, 450,yo);
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(xo,50,xo,yo+dy);
                        g.drawLine(xo,yo+dy,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+dx,50);
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo,yo,xo,370);
                        g.drawLine(xo+dx, 370, xo+dx,yo);
                        g.drawLine(xo+dx, yo, 450,yo);
                    }
                    else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo+anchoPing>=(450+dx)&&xo+anchoPing<=(450+2*dx)){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(xo,yo,xo,yo+dy);
                        g.drawLine(xo,yo+dy,450,yo+dy);
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(xo,50,xo,yo+dy);
                        g.drawLine(xo,yo+dy,450,yo+dy);
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo,yo,xo,370);
                    }
                    else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
               else if(xo+anchoPing>450+2*dx){
               }

                xo=xo+2*dx;
                yo=yo;
            }
            else if(ping[i]==0&ping[i-1]==1){
                if(xo>=50&&xo+anchoPing<=450){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+2*dx,yo+dy);
                    }
                    else if(yo<50&&yo>50-dy){
                       g.drawLine(xo+dx,50,xo+dx,yo+dy);
                       g.drawLine(xo+dx, yo+dy, xo+2*dx,yo+dy);
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,370);
                    }
                     else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo<50&&xo>=(50-dx)){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(50,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+2*dx,yo+dy);
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(xo+dx,50,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, xo+2*dx,yo+dy);
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(50,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,370);
                    }
                     else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo<(50-dx)&xo>=50-2*dx){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(50, yo+dy, xo+2*dx,yo+dy);
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(50, yo+dy, xo+2*dx,yo+dy);
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                    }
                     else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo+anchoPing>450&&xo+anchoPing<=(450+dx)){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, 450,yo+dy);
                    }
                    else if(yo<50&&yo>50-dy){
                        g.drawLine(xo+dx,50,xo+dx,yo+dy);
                        g.drawLine(xo+dx, yo+dy, 450,yo+dy);
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,370);
                    }
                     else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                else if(xo+anchoPing>=(450+dx)&&xo+anchoPing<=(450+2*dx)){
                    if(yo>=50&&yo+dy<370){
                        g.drawLine(xo,yo,450,yo);
                    }
                    else if(yo<50&&yo>50-dy){
                    }
                    else if(yo+dy>=370&&yo+dy<370+dy){
                        g.drawLine(xo,yo,450,yo);
                    }
                     else if(yo<=50-dy||yo+dy>=370+dy) {
                     }
                }
                xo=xo+2*dx;
                yo=yo+dy;
            }
            else if(ping[i]==1&ping[i-1]==0){
                if(xo>=50&&xo+anchoPing<=450){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+2*dx,yo-dy);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo-dy,xo+2*dx,yo);
                        }
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,50);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,50,xo+2*dx,yo);
                        }
                    }
                    else if(yo>=370&&yo<370+dy){
                        g.drawLine(xo+dx,370,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+2*dx,yo-dy);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo-dy,xo+2*dx,370);
                        }
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo<50&&xo>=(50-dx)){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(50,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+2*dx,yo-dy);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo-dy,xo+2*dx,yo);
                        }
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(50,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,50);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,50,xo+2*dx,yo);
                        }
                    }
                    else if(yo>=370&&yo<370+dy){
                        g.drawLine(xo+dx,370,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+2*dx,yo-dy);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo-dy,xo+2*dx,370);
                        }
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo<(50-dx)&xo>=50-2*dx){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(50, yo-dy, xo+2*dx,yo-dy);
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo-dy,xo+2*dx,yo);
                        }
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        if(i==ping.length-1){
                            g.drawLine(xo+2*dx,50,xo+2*dx,yo);
                        }
                    }
                    else if(yo>=370&&yo<370+dy){
                       g.drawLine(50, yo-dy, xo+2*dx,yo-dy);
                       if(i==ping.length-1){
                            g.drawLine(xo+2*dx,yo-dy,xo+2*dx,370);
                        }
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo+anchoPing>450&&xo+anchoPing<=(450+dx)){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(xo,yo,xo+dx,yo);
                        g.drawLine(xo+dx,yo,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, 450,yo-dy);   
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                       g.drawLine(xo,yo,xo+dx,yo);
                       g.drawLine(xo+dx,yo,xo+dx,50);
                    }
                    else if(yo>=370&&yo<370+dy){
                       g.drawLine(xo+dx,370,xo+dx,yo-dy);
                       g.drawLine(xo+dx, yo-dy, 450,yo-dy);
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo+anchoPing>=(450+dx)&&xo+anchoPing<=(450+2*dx)){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(xo,yo,450,yo);   
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                       g.drawLine(xo,yo,450,yo);
                    }
                    else if(yo>=370&&yo<370+dy){
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                xo=xo+2*dx;
                yo=yo-dy;
            }
            else if(ping[i]==0&ping[i-1]==0){
                if(xo>=50&&xo+anchoPing<=450){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(xo,yo,xo,yo-dy);
                        g.drawLine(xo,yo-dy,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);    
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(xo,yo,xo,50);
                        g.drawLine(xo+dx, 50, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);
                    }
                     else if(yo>=370&&yo<370+dy){
                        g.drawLine(xo,370,xo,yo-dy);
                        g.drawLine(xo,yo-dy,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+dx,370);
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo<50&&xo>=(50-dx)){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(50,yo-dy,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);    
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(xo+dx, 50, xo+dx,yo);
                        g.drawLine(xo+dx, yo, xo+2*dx,yo);
                    }
                     else if(yo>=370&&yo<370+dy){
                        g.drawLine(50,yo-dy,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+dx,370);
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo<(50-dx)&xo>=50-2*dx){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(50, yo, xo+2*dx,yo);    
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(50, yo, xo+2*dx,yo);
                    }
                     else{

                    }
                }
                else if(xo+anchoPing>450&&xo+anchoPing<=(450+dx)){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(xo,yo,xo,yo-dy);
                        g.drawLine(xo,yo-dy,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+dx,yo);
                        g.drawLine(xo+dx, yo, 450,yo);   
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(xo,yo,xo,50);
                        g.drawLine(xo+dx, 50, xo+dx,yo);
                        g.drawLine(xo+dx, yo, 450,yo);
                    }
                     else if(yo>=370&&yo<370+dy){
                        g.drawLine(xo,370,xo,yo-dy);
                        g.drawLine(xo,yo-dy,xo+dx,yo-dy);
                        g.drawLine(xo+dx, yo-dy, xo+dx,370);
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo+anchoPing>=(450+dx)&&xo+anchoPing<=(450+2*dx)){
                    if(yo-dy>=50&&yo<370){
                        g.drawLine(xo,yo,xo,yo-dy);
                        g.drawLine(xo,yo-dy,450,yo-dy);   
                    }
                    else if(yo-dy<50&&yo-dy>50-dy){
                        g.drawLine(xo,yo,xo,50);
                    }
                     else if(yo>=370&&yo<370+dy){
                       g.drawLine(xo,370,xo,yo-dy);
                       g.drawLine(xo,yo-dy,450,yo-dy);
                    }
                    else if(yo-dy<=50-dy||yo>=370+dy) {
                     }
                }
                else if(xo+anchoPing>=(450+2*dx)){

                }
                xo=xo+2*dx;
                yo=yo;
            }
        }//end for
                       
        g.setColor((Color.green).darker());
        g.drawLine(border,border,gb,border);
        g.drawLine(border,ygridSize+border,gb,ygridSize+border);
        g.drawLine(border,border,border,ygridSize+border);
        g.drawLine(gb,border,gb,ygridSize+border);
    }

    public void actionPerformed(ActionEvent evt){
			
        if(evt.getSource() == plusVolt){
            if(vPointer!=0){
                vPointer--;
                escalaY=escalaY/2;
            }
            tVolt.setText(volt[vPointer]+ " V");
            repaint();
        }
        if(evt.getSource() == minusVolt){
               if(vPointer < volt.length-1){
                    vPointer++;
                    escalaY=escalaY*2;
                }
                tVolt.setText(volt[vPointer]+ " V");
                repaint(); 
        }
        if(evt.getSource() == minusTime){
                if(indiceXslider!=resolXslider.length-1){
                    indiceXslider++;
                }
                if(tPointer!=0){
                    tPointer--;
                    escalaX=escalaX*2;
                    xslider.setAutoscrolls(true);
                    value=xslider.getX();
                    xslider.setMinimum(-resolXslider[indiceXslider]);
                    xslider.setMaximum(resolXslider[indiceXslider]);
                    xslider.setExtent(value);
                }
                tTime.setText(time[tPointer]+ " uS");
                repaint();

            }
        if(evt.getSource() == plusTime){
                if(indiceXslider!=0){
                    indiceXslider--;
                }
                if(tPointer < time.length-1){
                    tPointer++;
                    escalaX=escalaX/2;
                    value=xslider.getX();
                    xslider.setMinimum(-resolXslider[indiceXslider]);
                    xslider.setMaximum(resolXslider[indiceXslider]);
                    xslider.setExtent(value);
                }	
                tTime.setText(time[tPointer]+ " uS");
                repaint();
        }
        if(evt.getSource() == solucion){
            solucion.setVisible(false);
            nosolucion.setVisible(true);
            sol=true;
            preambulo.setVisible(true);
            sfd.setVisible(true);
            datos.setVisible(true);
            crc.setVisible(true);
            repaint();
        }
        if(evt.getSource() == nosolucion){
            solucion.setVisible(true);
            nosolucion.setVisible(false);
            sol=false;
            preambulo.setVisible(false);
            sfd.setVisible(false);
            datos.setVisible(false);
            crc.setVisible(false);
            repaint();
        }
        repaint();
   }

    private String getVolt(){
        return volt[vPointer] + " V";	
    }// end getVolts()

    private String getTime(){
        return time[tPointer]+ " uS";
    }// end getTime()  
    
}
