
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Practica_Cablemeter extends javax.swing.JApplet implements ActionListener, MouseListener {
    
    private javax.swing.JButton botonActualizar;
    private javax.swing.JRadioButton botonCable1;
    private javax.swing.JRadioButton botonCable2;
    private javax.swing.JRadioButton botonCable3;
    private javax.swing.JRadioButton botonCable4;
    private javax.swing.JRadioButton botonLength;
    private javax.swing.JButton botonMostrar;
    private javax.swing.JCheckBox botonPrueba;
    private javax.swing.JRadioButton botonTest;
    private javax.swing.JRadioButton botonWiremap;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private JLayeredPane fondoP31;
    Image back,image;
    private JLabel background;
   
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    public javax.swing.JScrollPane jScrollPane1;
    public PanelCables panelCables1;
    public PanelCables panelCables2;
    public PanelCables panelCables3;
    public PanelCables panelCables4;
    public javax.swing.JTextPane panelTexto;
    
    private int[] propiedadesC1= new int[6];
    private int[] propiedadesC2= new int[6];
    private int[] propiedadesC3= new int[6];
    private int[] propiedadesC4= new int[6];
    public int[] propAux=new int[6];
    private char[] caracteres = new char[2];
    private int cable=0,banderaC=0;
    private double cableEnCorto;
    private boolean test=false,length=false,wire=false,prueba=false;
    private int longModoLen;
    
    @Override
    public void init() {
        
        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        fondoP31 = new JLayeredPane();
        panelTexto = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        botonPrueba = new javax.swing.JCheckBox();
        botonTest = new javax.swing.JRadioButton();
        botonLength = new javax.swing.JRadioButton();
        botonWiremap = new javax.swing.JRadioButton();
        panelCables2 = new PanelCables(this);
        panelCables4 = new PanelCables(this);
        panelCables3 = new PanelCables(this);
        panelCables1 = new PanelCables(this);
        botonCable1 = new javax.swing.JRadioButton();
        botonCable3 = new javax.swing.JRadioButton();
        botonCable4 = new javax.swing.JRadioButton();
        botonCable2 = new javax.swing.JRadioButton();
        botonActualizar = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        botonMostrar = new javax.swing.JButton();
        Font f = new Font("Arial",Font.PLAIN,14);
        Font f1 = new Font("Arial",Font.PLAIN,12);

           
        fondoP31.setBackground(Color.white);
        setBackground(Color.white);
        setSize(1010,617);
        fondoP31.setLayout(null);
        setVisible(true);
        
        jLabel1.setFont(new java.awt.Font("Arial", 0, 24));
        jLabel1.setText("    CABLES");
        jLabel1.setBounds(600,37,137,40);
        jLabel1.setToolTipText("Zona de soluciones");
        jLabel1.setVisible(true);
        fondoP31.add(jLabel1);
        
        jLabel2.setFont(new java.awt.Font("Arial", 0, 24));
        jLabel2.setText(" CABLEMETER");
        jLabel2.setBounds(120,37,168,40);
        jLabel2.setToolTipText("Zona de prueba");
        jLabel2.setVisible(true);
        fondoP31.add(jLabel2);
         
        panelTexto.setEditable(false);
        panelTexto.setFont(new java.awt.Font("Tahoma", 0, 16));
        jScrollPane1.setBounds(98,105,220,125);
        panelTexto.setVisible(true);
        jScrollPane1.setViewportView(panelTexto);
        fondoP31.add(jScrollPane1);
        
        botonMostrar.setFont(f);
        botonMostrar.setText("MOSTRAR");
        botonMostrar.setBounds(140,245,138,38);
        botonMostrar.setVisible(true);
        botonMostrar.addActionListener(this);
        fondoP31.add(botonMostrar);
        
        botonTest.setFont(f);
        botonTest.setBackground(new java.awt.Color(204, 204, 255));
        botonTest.setText("   TEST");
        botonTest.setBounds(155,305,98,28);
        botonTest.addActionListener(this);
        botonTest.setVisible(true);
        buttonGroup1.add(botonTest);
        fondoP31.add(botonTest);
        
        botonLength.setFont(f);
        botonLength.setBackground(new java.awt.Color(204, 204, 255));
        botonLength.setText(" LENGTH");
        botonLength.setBounds(155,353,98,28);
        botonLength.addActionListener(this);
        botonLength.setVisible(true);
        buttonGroup1.add(botonLength);
        fondoP31.add(botonLength);
       
        botonWiremap.setFont(f);
        botonWiremap.setBackground(new java.awt.Color(204, 204, 255));
        botonWiremap.setText("WIRE_MAP");
        botonWiremap.setBounds(155,401,98,28);
        botonWiremap.addActionListener(this);
        botonWiremap.setVisible(true);
        buttonGroup1.add(botonWiremap);
        fondoP31.add(botonWiremap);
        
        botonPrueba.setFont(f);
        botonPrueba.setBackground(new java.awt.Color(204, 204, 255));
        botonPrueba.setText("Prueba");
        botonPrueba.setBounds(110,467,85,20);
        botonPrueba.addActionListener(this);
        botonPrueba.setVisible(true);
        fondoP31.add(botonPrueba);
        
        panelCables1.setName("panelCables1");
        panelCables1.setOpaque(true);
        panelCables1.setBounds(468,167,125,120);
        panelCables1.setToolTipText("Pulsar para ver solución");
        panelCables1.addMouseListener(this);
        panelCables1.setVisible(true);
        fondoP31.add(panelCables1);
        
        panelCables2.setName("panelCables2");
        panelCables2.setOpaque(true);
        panelCables2.setBounds(763,167,125,120);
        panelCables2.setToolTipText("Pulsar para ver solución");
        panelCables2.addMouseListener(this);
        panelCables2.setVisible(true);
        fondoP31.add(panelCables2);
        
        panelCables3.setName("panelCables3");
        panelCables3.setOpaque(true);
        panelCables3.setBounds(468,357,125,120);
        panelCables3.setToolTipText("Pulsar para ver solución");
        panelCables3.addMouseListener(this);
        panelCables3.setVisible(true);
        fondoP31.add(panelCables3);
        
        panelCables4.setName("panelCables4");
        panelCables4.setOpaque(true);
        panelCables4.setBounds(763,357,125,120);
        panelCables4.setToolTipText("Pulsar para ver solución");
        panelCables4.addMouseListener(this);
        panelCables4.setVisible(true);
        fondoP31.add(panelCables4);
        
        botonCable1.setBackground(new java.awt.Color(153, 255, 255));
        botonCable1.setBounds(593,217,20,20);
        botonCable1.addActionListener(this);
        botonCable1.setVisible(true);
        buttonGroup2.add(botonCable1);
        fondoP31.add(botonCable1);
        
        botonCable2.setBackground(new java.awt.Color(153, 255, 255));
        botonCable2.setBounds(743,217,20,20);
        botonCable2.addActionListener(this);
        botonCable2.setVisible(true);
        buttonGroup2.add(botonCable2);
        fondoP31.add(botonCable2);
        
        botonCable3.setBackground(new java.awt.Color(153, 255, 255));
        botonCable3.setBounds(593,407,20,20);
        botonCable3.addActionListener(this);
        botonCable3.setVisible(true);
        buttonGroup2.add(botonCable3);
        fondoP31.add(botonCable3);
        
        botonCable4.setBackground(new java.awt.Color(153, 255, 255));
        botonCable4.setBounds(743,407,20,20);
        botonCable4.addActionListener(this);
        botonCable4.setVisible(true);
        buttonGroup2.add(botonCable4);
        fondoP31.add(botonCable4);
        
        botonActualizar.setFont(f1);
        botonActualizar.setText("Generar Nuevas Averías");
        botonActualizar.setBounds(588,308,185,25);
        botonActualizar.setToolTipText("Al pulsar este boton las averias de los cables cambian");
        botonActualizar.addActionListener(this);
        botonActualizar.setVisible(true);
        fondoP31.add(botonActualizar);
       
        back =getImage("FondoP3.jpg");
        ImageIcon bgicon = new ImageIcon(back);
        background = new JLabel(bgicon);
        background.setOpaque(true);
        background.setBounds(0,0,bgicon.getIconWidth(), bgicon.getIconHeight());
        fondoP31.add(background,new Integer(0));
        getContentPane().setBackground(Color.white);
        getContentPane().add(fondoP31);
        
        for(int a=0;a<2;a++){
            propiedadesC1=panelCables1.propiedades(2);
            for(int i=0;i<1000000;i++){}
            propiedadesC2=panelCables2.propiedades(8);
            for(int i=0;i<2000000;i++){}
            propiedadesC3=panelCables3.propiedades(3);
            for(int i=0;i<4000000;i++){}
            propiedadesC4=panelCables4.propiedades(1);
        }
        caracteres[0]='-';
        caracteres[1]='-';
    }
    
    @Override
    public void actionPerformed(ActionEvent e) {
        if(e.getSource()==botonMostrar){
            MostrarPulsado();
        }
        if(e.getSource()==botonTest){
            test=true;
            length=false;
            wire=false;
            panelTexto.setText("\n");
        }
        if(e.getSource()==botonLength){
            test=false;
            length=true;
            wire=false;
            panelTexto.setText("\n");
        }
        if(e.getSource()==botonWiremap){
            test=false;
            length=false;
            wire=true;
            panelTexto.setText("\n");
        }
        if(e.getSource()==botonPrueba){
            panelTexto.setText("\n");
            if(botonPrueba.isSelected()){
                prueba=true;
                caracteres[0]='#';//para modo test
                caracteres[1]='1';
            }
            else{
                prueba=false;
                caracteres[0]='-';//para modo test
                caracteres[1]='-';
            }
        }
        if(e.getSource()==botonCable1){
            panelTexto.setText("\n");
            cable=1; 
        }
        if(e.getSource()==botonCable2){
            panelTexto.setText("\n");
            cable=2; 
        }
        if(e.getSource()==botonCable3){
            panelTexto.setText("\n");
            cable=3; 
        }
        if(e.getSource()==botonCable4){
            panelTexto.setText("\n");
            cable=4; 
        }
        if(e.getSource()==botonActualizar){
            propiedadesC1=panelCables1.propiedades(1);
            for(int i=0;i<1000000;i++){}
            propiedadesC2=panelCables2.propiedades(5);
            for(int i=0;i<2000000;i++){}
            propiedadesC3=panelCables3.propiedades(9);
            for(int i=0;i<4000000;i++){}
            propiedadesC4=panelCables4.propiedades(7);
            panelTexto.setText("\n");
        }
    }
    
    @Override
    public void mouseClicked(MouseEvent e) {
    
    }

    @Override
    public void mousePressed(MouseEvent e) {
        
        if(e.getSource()==panelCables1){
            for(int i=0;i<5;i++){//inicializacion del bucle auxiliar
                propAux[i]=0;
            }
            banderaC=1;
            propAux[0]=propiedadesC1[0];//PARA TEST-->tipo averia//PARA LENGTH-->tipo averia
            propAux[1]=propiedadesC1[1];//PARA TEST-->par en corto o abierto(del mismo par o distinto)//PARA LENGTH-->longitud par 12
            propAux[2]=propiedadesC1[2];//PARA TEST-->un cable abierto//PARA LENGTH-->longitud par 36
            propAux[3]=propiedadesC1[3];//PARA TEST-->nada//PARA LENGTH-->longitud par 45
            propAux[4]=propiedadesC1[4];//PARA TEST-->longitud a la que esta la averia//PARA LENGTH-->longitud par 78
            propAux[5]=propiedadesC1[5];//PARA TEST-->longitud del cable//PARA LENGTH-->nada
            VerInfoCable();
        }
        if(e.getSource()==panelCables2){
            for(int i=0;i<5;i++){//inicializacion del bucle auxiliar
                propAux[i]=0;
            }
            banderaC=2;
            propAux[0]=propiedadesC2[0];//PARA WIREMAP-->tipo averia
            propAux[1]=propiedadesC2[1];//PARA WIREMAP-->par que esta en circuito abierto || par en corto(del mismo par o distinto)
            propAux[2]=propiedadesC2[2];//PARA WIREMAP-->cable abierto
            propAux[3]=propiedadesC2[3];//PARA WIREMAP-->si el cambio de los cables esta en el extremo cercano o lejano. Si el par o cable en corto esta en el extremo lejano o cercano
            propAux[4]=propiedadesC2[4];//PARA WIREMAP-->nada
            propAux[5]=propiedadesC2[5];//PARA WIREMAP-->nada
            VerInfoCable();
        }
        if(e.getSource()==panelCables3){
            for(int i=0;i<5;i++){//inicializacion del bucle auxiliar
                propAux[i]=0;
            }
            banderaC=3;
            propAux[0]=propiedadesC3[0];
            propAux[1]=propiedadesC3[1];
            propAux[2]=propiedadesC3[2];
            propAux[3]=propiedadesC3[3];
            propAux[4]=propiedadesC3[4];
            propAux[5]=propiedadesC3[5];
            VerInfoCable();
        }
        if(e.getSource()==panelCables4){
            for(int i=0;i<5;i++){//inicializacion del bucle auxiliar
                propAux[i]=0;
            }
           banderaC=4;
           propAux[0]=propiedadesC4[0];
           propAux[1]=propiedadesC4[1];
           propAux[2]=propiedadesC4[2];
           propAux[3]=propiedadesC4[3];
           propAux[4]=propiedadesC4[4];
           propAux[5]=propiedadesC4[5];
           VerInfoCable();
        }
    }

    @Override
    public void mouseReleased(MouseEvent e) {
    }

    @Override
    public void mouseEntered(MouseEvent e) { 
    }

    @Override
    public void mouseExited(MouseEvent e) {
    }

    private void VerInfoCable() {                              
        if(cable!=0){   
              if(cable==banderaC){
                if(propAux[0]==0){//No esta averiado
                   JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "El cable esta en perfecto estado y tiene una longitud de "+propAux[5]+" m","Solucion",1); 
                }
                else if((propAux[0]==1)){//Cortocircuito lejano mismo par
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "El cable tiene un cortocircuito lejano"
                            + " en los cables de un mismo par,\npar "+propAux[1],"Solucion",1);
                }
                else if(propAux[0]==2){//Cortocircuito lejano distinto par
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "El cable tiene un cortocircuito lejano"
                            + " en los cables de distinto par,\ncorto cables "+propAux[1],"Solucion",1);
                }
                else if(propAux[0]==3){//Cortocircuito cercano mismo par
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "El cable tiene un cortocircuito cercano"
                            + " en los cables de un mismo par,\npar "+propAux[1],"Solucion",1);
                }
                else if(propAux[0]==4){//Cortocircuito cercano distinto par
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "El cable tiene un cortocircuito cercano"
                            + " en los cables de distinto par,\ncorto cables "+propAux[1],"Solucion",1);
                }
                else if(propAux[0]==5){//Un cable abierto
                  
                  if(propAux[3]==1){//Abierto en el extremo cercano  
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "Circuito abierto en el cable "+propAux[2]+" en el extremo cercano","Solucion",1);
                  }
                  else if(propAux[3]==2){//Abierto en el extremo lejano
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "Circuito abierto en el cable "+propAux[2]+" en el extremo lejano","Solucion",1);  
                  }
                }
                else if(propAux[0]==6){//Par abierto
                    
                  if(propAux[3]==1){//Abierto en el extremo cercano  
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "Circuito abierto en el par "+propAux[1]+" en el extremo cercano","Solucion",1);
                  }
                  else if(propAux[3]==2){//Abierto en el extremo lejano
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "Circuito abierto en el par "+propAux[1]+" en el extremo lejano","Solucion",1); 
                  }
                }
                else{//propAux[0]==7; Cables cambiados
                    
                  if(propAux[3]==1){//Cambiados en el extremo cercano  
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "Par "+propAux[1]+"  cambiados en el extremo cercano","Solucion",1);
                  }
                  else if(propAux[3]==2){//Cambiados en el extremo lejano
                    JOptionPane.showMessageDialog(null,"Cable UTP tipo EIA/TIA, 4 pares de categoria5\n\n"+
                             "Par "+propAux[1]+" mal conectado en el extremo lejano","Solucion",1);  
                  }
                }
              }
              else{
                  JOptionPane.showMessageDialog(null,"Solo puedes ver la solucion del cable seleccionado","Aviso",0);
              }
        }
        else{
            JOptionPane.showMessageDialog(null,"Debes de seleccionar un cable para poder ver la solucion","Aviso",0); 
        }
          
    }                             
                                                        
    private void MostrarPulsado() {                                
        for(int i=0;i<6;i++){//inicializacion del bucle
            propAux[i]=0;
        }
        
        if(cable==0){//no se ha seleccionado ningun cable
            JOptionPane.showMessageDialog(null,"No se ha seleccionado ningun cable","Aviso",0);
            
        }
        else{//se ha seleccionado algun cable
            if(cable==1){
                propAux[0]=propiedadesC1[0];//PARA TEST-->tipo averia//PARA LENGTH-->tipo averia
                propAux[1]=propiedadesC1[1];//PARA TEST-->par en corto o abierto(del mismo par o distinto)//PARA LENGTH-->longitud par 12
                propAux[2]=propiedadesC1[2];//PARA TEST-->un cable abierto//PARA LENGTH-->longitud par 36
                propAux[3]=propiedadesC1[3];//PARA TEST-->nada//PARA LENGTH-->longitud par 45
                propAux[4]=propiedadesC1[4];//PARA TEST-->longitud a la que esta la averia//PARA LENGTH-->longitud par 78
                propAux[5]=propiedadesC1[5];//PARA TEST-->longitud del cable//PARA LENGTH-->nada
            
            }
            else if(cable==2){
                propAux[0]=propiedadesC2[0];//PARA WIREMAP-->tipo averia
                propAux[1]=propiedadesC2[1];//PARA WIREMAP-->par que esta en circuito abierto || par en corto(del mismo par o distinto)
                propAux[2]=propiedadesC2[2];//PARA WIREMAP-->cable abierto
                propAux[3]=propiedadesC2[3];//PARA WIREMAP-->si el cambio de los cables esta en el extremo cercano o lejano. si el par en circuito abierto es lejano o cercano
                propAux[4]=propiedadesC2[4];//PARA WIREMAP-->nada
                propAux[5]=propiedadesC2[5];//PARA WIREMAP-->nada
          
            }
            else if(cable==3){
                propAux[0]=propiedadesC3[0];
                propAux[1]=propiedadesC3[1];
                propAux[2]=propiedadesC3[2];
                propAux[3]=propiedadesC3[3];
                propAux[4]=propiedadesC3[4];
                propAux[5]=propiedadesC3[5];
            
            }
            else if(cable==4){
               propAux[0]=propiedadesC4[0];
               propAux[1]=propiedadesC4[1];
               propAux[2]=propiedadesC4[2];
               propAux[3]=propiedadesC4[3];
               propAux[4]=propiedadesC4[4];
               propAux[5]=propiedadesC4[5];
         
            }
            cableEnCorto=((double)propAux[1]/10)+0.01; // Cuando el cable en corto es de distinto par
                    while(cableEnCorto>0.9){           //se hace esto para separar los cables para 
                        cableEnCorto=cableEnCorto-1;   //luego poder escribirlos asi: cable1&cable2 
                    }
                    cableEnCorto=cableEnCorto*10;

            if(test){//si esta seleccionado test
              if(propAux[0]==0){//El cable no esta averiado
                      
                    panelTexto.setText("\n  PASA\t\tID"+caracteres[0]+caracteres[1]+"\n  "+propAux[5]+" m"); //BIEN 
              }
              else{//El cable esta averiado
                  if(propAux[0]==1||propAux[0]==2){//Cortocircuito lejano del mismo o distinto par con o sin prueba BIEN
                    panelTexto.setText("\n  FALLO\t\tID"+caracteres[0]+caracteres[1]+"\n  "+(int)(propAux[1]/10)+"&"+(int)cableEnCorto+"   CORTO <\t"+propAux[5]+" m");//BIEN 
                  }
                  else if(propAux[0]==3||propAux[0]==4){//Cortocircuito cercano del mismo o distinto par con y sin prueba BIEN
                    panelTexto.setText("\n  FALLO\t\tID"+caracteres[0]+caracteres[1]+"\n  "+(int)(propAux[1]/10)+"&"+(int)cableEnCorto+"   CORTO <\t"+propAux[4]+" m");//BIEN  
                  }
                  else if(propAux[0]==5){//Cable abierto BIEN 9-9-2011
                    if(propAux[3]==1&prueba){//Abierto en el extremo cercano con prueba
                        panelTexto.setText("\n  FALLO\t\t   ID"+caracteres[0]+caracteres[1]+"\n  "+propAux[2]+"   ABIERTO @  0.0 m");//BIEN
                    }
                    else if(propAux[3]==1&!prueba){//Abierto en el extremo cercano sin prueba
                        if(propAux[2]!=(int)cableEnCorto){
                            panelTexto.setText("\n  FALLO\t\t   ID"+caracteres[0]+caracteres[1]+"\n  "+propAux[2]+"&"+(int)cableEnCorto+"  ABIERTO @  0.0 m");//BIEN
                        }
                        else{
                            panelTexto.setText("\n  FALLO\t\t   ID"+caracteres[0]+caracteres[1]+"\n  "+(int)(propAux[1]/10)+"&"+(int)cableEnCorto+"  ABIERTO @  0.0 m");
                        }       
                    }
                    else if(propAux[3]==2&prueba){//Abierto en el extremo lejano con prueba
                        panelTexto.setText("\n  FALLO\t\t   ID"+caracteres[0]+caracteres[1]+"\n    "+propAux[2]+"  ABIERTO @ "+propAux[4]+" m");//BIEN
                    }
                    else if(propAux[3]==2&!prueba){//Abierto en el extremo lejano sin prueba
                        panelTexto.setText("\n  PASA\t\tID"+caracteres[0]+caracteres[1]+"\n  "+propAux[5]+" m");//BIEN
                    }
                  }
                  else if(propAux[0]==6){//Par abierto BIEN
                   if(propAux[3]==1){//Abierto en el extremo cercano
                        panelTexto.setText("\n  FALLO\t\t   ID"+caracteres[0]+caracteres[1]+"\n  "+(int)(propAux[1]/10)+"&"+(int)cableEnCorto+"  ABIERTO @  0.0 m");
                    }
                    else if(propAux[3]==2){//Abierto en el extremo lejano
                        if(prueba){
                            panelTexto.setText("\n  FALLO\t\t   ID"+caracteres[0]+caracteres[1]+"\n  "+(int)(propAux[1]/10)+"&"+(int)cableEnCorto+"  ABIERTO @ "+propAux[4]+" m");
                        }
                        else{
                            panelTexto.setText("\n  PASA\t\tID"+caracteres[0]+caracteres[1]+"\n  "+propAux[5]+" m");
                        }
                     }
                  }
                  else{//propAux[0]==7; Pares cambiados 
                    if(prueba){//Cambiados en el extremo lejano y cercano con prueba
                        if(propAux[1]==12){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  ");
                            panelTexto.setText("\n   2 1  3 6  4 5  7 8  \n"+panelTexto.getText());
                        }
                        else if(propAux[1]==36){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  "+panelTexto.getText());
                            panelTexto.setText("\n   1 2  6 3  4 5  7 8  \n"+panelTexto.getText());
                        }
                        else if(propAux[1]==45){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  "+panelTexto.getText());
                            panelTexto.setText("\n   1 2  3 6  5 4  7 8  \n"+panelTexto.getText());
                        }
                        else if(propAux[1]==78){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  "+panelTexto.getText());
                            panelTexto.setText("\n   1 2  3 6  4 5  8 7  \n"+panelTexto.getText());
                        }
                        panelTexto.setText("\n  FALLO\t\t ID"+caracteres[0]+caracteres[1]+"\n MALA CONEXION\n\n  "+panelTexto.getText());
                    }
                    else{//Cambiados en el extremo lejano y cercano sin prueba
                        panelTexto.setText("\n  PASA\t\tID"+caracteres[0]+caracteres[1]+"\n  "+propAux[5]+" m");
                    }
                  }
              }
            }
            else if(length){//length seleccionado
                if(propAux[0]==0){//si no esta averiado BIEN
                    panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                    panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                    panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                    panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                }
                else if(propAux[0]==1||propAux[0]==3){//corto mismo par BIEN
                    if(propAux[0]==1){//corto lejano mismo par con y sin prueba
                        longModoLen=propAux[5];
                    }
                    else if(propAux[0]==3){//corto cercano mismo par con y sin prueba
                        longModoLen=propAux[4];
                    }
                    if(propAux[1]==12){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1&2 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==36){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  3&6 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==45){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  4&5 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else{
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  7&8 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                }
                else if(propAux[0]==2||propAux[0]==4){//corto distinto par BIEN
                    if(propAux[0]==2){//corto lejano distinto par con y sin prueba
                        longModoLen=propAux[5];
                    }
                    else if(propAux[0]==4){//corto cercano distinto par con y sin prueba
                        longModoLen=propAux[4];
                    }
                    if(propAux[1]==13&&prueba){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1&3 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==13&&!prueba){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("   6  ABIERTO @\n"+panelTexto.getText());
                        panelTexto.setText("   2  ABIERTO @\n"+panelTexto.getText());
                        panelTexto.setText("  1&3 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==34&&prueba){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  3&4 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==34&&!prueba){
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("   5  ABIERTO @\n"+panelTexto.getText());
                        panelTexto.setText("   6  ABIERTO @\n"+panelTexto.getText());
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  3&4 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==58&&prueba){
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m");
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  5&8 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==58&&!prueba){
                        panelTexto.setText("   7  ABIERTO @");
                        panelTexto.setText("   5  ABIERTO @\n"+panelTexto.getText());
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  5&8 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==27&&prueba){
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  2&7 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                    else if(propAux[1]==27&&!prueba){
                        panelTexto.setText("   8  ABIERTO @");
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("   1  ABIERTO @"+panelTexto.getText());
                        panelTexto.setText("  2&7 CORTO < "+longModoLen+" m\n"+panelTexto.getText());
                    }
                }
                else if(propAux[0]==5){//cable abierto BIEN FALTA COMENTAR CODIGO
                    if(propAux[3]==1){// Abierto en el extremo cercano
                        if(prueba){// Con prueba
                            if(propAux[2]==1||propAux[2]==2){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==3||propAux[2]==6){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==4||propAux[2]==5){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==7||propAux[2]==8){
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }    
                        }
                        else{// Sin prueba
                            if(propAux[2]==1||propAux[2]==2){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1&2 ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==3||propAux[2]==6){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3&6 ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==4||propAux[2]==5){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  4&5 ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==7||propAux[2]==8){
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  7&8 ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }  
                        }
                    }
                    else if(propAux[3]==2){//Abierto en el extremo lejano
                        if(prueba){// Con prueba
                            if(propAux[2]==1||propAux[2]==2){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==3||propAux[2]==6){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==4||propAux[2]==5){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==7||propAux[2]==8){
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  "+propAux[2]+" ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }   
                        }  
                        else{// Sin prueba
                            panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                            panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        }       
                    }   
                }
                else if(propAux[0]==6){//par abierto 
                    if(propAux[3]==1){
                        if(propAux[2]==1||propAux[2]==2){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1&2  ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==3||propAux[2]==6){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3&6  ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==4||propAux[2]==5){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  4&5  ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==7||propAux[2]==8){
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  7&8  ABIERTO @ 0.0 m\n"+panelTexto.getText());   
                            }
                    }
                    if(propAux[3]==2){
                        if(prueba){
                            if(propAux[2]==1||propAux[2]==2){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1&2  ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==3||propAux[2]==6){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  3&6  ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==4||propAux[2]==5){
                                panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  4&5  ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                            else if(propAux[2]==7||propAux[2]==8){
                                panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                                panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                                panelTexto.setText("  7&8  ABIERTO @ "+propAux[4]+" m\n"+panelTexto.getText());   
                            }
                        }
                        else{
                            panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                            panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        }
                        
                    }
                }
                else{//propAux[1]==7 pares cambiados
                    if(prueba){
                        if(propAux[1]==12){
                            panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                            panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  2 1\tERROR "+propAux[5]+" m\n"+panelTexto.getText());
                        }
                        else if(propAux[1]==36){
                            panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                            panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  6 3\tERROR "+propAux[5]+" m\n"+panelTexto.getText());
                        }
                        else if(propAux[1]==45){
                            panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                            panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  5 4\tERROR "+propAux[5]+" m\n"+panelTexto.getText());
                        }
                        else if(propAux[1]==78){
                            panelTexto.setText("  4 5\t\t"+propAux[5]+" m");
                            panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                            panelTexto.setText("  8 7\tERROR "+propAux[5]+" m\n"+panelTexto.getText());
                        }
                    }
                    else{
                        panelTexto.setText("  7 8\t\t"+propAux[5]+" m");
                        panelTexto.setText("  4 5\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  3 6\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                        panelTexto.setText("  1 2\t\t"+propAux[5]+" m\n"+panelTexto.getText());
                    }
                }
            }
            else if(wire){//wiremap seleccionado BIEN
                if(propAux[0]==0){//no esta averiado con y sin prueba BIEN
                  panelTexto.setText("   1 2  3 6  4 5  7 8  "+caracteres[0]+caracteres[1]);
                  panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                }
                else if(propAux[0]==1||propAux[0]==3){//Cortocircuito lejano o cercano mismo par con y sin prueba BIEN
                      if(propAux[1]==12){//par 12
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else if(propAux[1]==36){//par 36
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   3 6  1 2  4 5  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else if(propAux[1]==45){//par 45
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   4 5  1 2  3 6  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else{//par 78
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   7 8  1 2  3 6  4 5  ID\n"+panelTexto.getText());
                      }
                }
                else if(propAux[0]==2||propAux[0]==4){ 
                    if(propAux[1]==13){
                            panelTexto.setText("   c c                       "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   1 3  2  6  4 5  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else if(propAux[1]==34){
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   3 4  1 2  6  5  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else if(propAux[1]==58){
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   5 8  1 2  3 6  4  7  ID\n"+panelTexto.getText()); 
                      }
                      else{//27
                            panelTexto.setText("   c c                     "+caracteres[0]+caracteres[1]);
                            panelTexto.setText("\n   2 7  1  3 6  4 5  8  ID\n"+panelTexto.getText());
                      }
                    
                    
                    
                }
                else if(propAux[0]==5){//Cable abierto BIEN
                    if(propAux[3]==1){//Abierto extremo cercano BIEN
                      if(propAux[2]==1){//Abierto cable1
                          if(prueba){
                            panelTexto.setText("     2  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   a 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   a a  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==2){//Abierto cable2
                          if(prueba){
                            panelTexto.setText("   1    3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 a  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   a a  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==3){//Abierto cable3
                          if(prueba){
                            panelTexto.setText("   1 2    6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  a 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  a a  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==4){//Abierto cable4
                          if(prueba){
                            panelTexto.setText("   1 2  3 6    5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  a 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  a a  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==5){//Abierto cable5
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4    7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 a  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  a a  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==6){//Abierto cable6
                          if(prueba){
                            panelTexto.setText("   1 2  3    4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 a  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  a a  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      } 
                      else if(propAux[2]==7){//Abierto cable7
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 5    8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  a 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  a a  ID\n"+panelTexto.getText());
                          }
                      }
                      else{//Abierto cable8
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 5  7    #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 a  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  a a  ID\n"+panelTexto.getText());
                          }
                      }
                    }
                    else if(propAux[3]==2){//Abierto extremo lejano BIEN
                      if(propAux[2]==1){
                          if(prueba){
                            panelTexto.setText("   a 2  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==2){
                          if(prueba){
                            panelTexto.setText("   1 a  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==3){
                          if(prueba){
                            panelTexto.setText("   1 2  a 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==4){
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  a 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==5){
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 a  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[2]==6){
                          if(prueba){
                            panelTexto.setText("   1 2  3 a  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      } 
                      else if(propAux[2]==7){
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 5  a 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else{
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 5  7 a  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }  
                        
                    }
                
                }
                else if(propAux[0]==6){//Par abierto 
                    if(propAux[3]==1){//Abierto extremo cercano BIEN
                      if(propAux[1]==12){//
                          if(prueba){
                            panelTexto.setText("        3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   a a  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   a a  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[1]==36){
                          if(prueba){
                            panelTexto.setText("   1 2       4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  a a  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  a a  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[1]==45){
                          if(prueba){
                            panelTexto.setText("   1 2  3 6       7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  a a  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  a a  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else{
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 5       #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  a a  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  a a  ID\n"+panelTexto.getText());
                          }
                      }
                    }
                    else if(propAux[3]==2){//abierto extremo lejano BIEN
                      if(propAux[1]==12){
                          if(prueba){
                            panelTexto.setText("   a a  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[1]==36){
                          if(prueba){
                            panelTexto.setText("   1 2  a a  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else if(propAux[1]==45){
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  a a  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                      else{
                          if(prueba){
                            panelTexto.setText("   1 2  3 6  4 5  a a  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                          }
                          else{
                            panelTexto.setText("                             --");
                            panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                          }
                      }
                    }
                }
                else{//Cables cambiados FALTA POR HACER
                    if(prueba){//Cambiados extremo cercano
                      if(propAux[1]==12){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   2 1  3 6  4 5  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else if(propAux[1]==36){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  6 3  4 5  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else if(propAux[1]==45){
                            panelTexto.setText("   1 2  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  5 4  7 8  ID\n"+panelTexto.getText()); 
                      }
                      else{
                            panelTexto.setText("   1 2  3 6  4 5  7 8  #1");
                            panelTexto.setText("\n   1 2  3 6  4 5  8 7  ID\n"+panelTexto.getText());
                      }
                    }
                    else{ 
                        panelTexto.setText("   1 2  3 6  4 5  7 8  --");
                        panelTexto.setText("\n   1 2  3 6  4 5  7 8  ID\n"+panelTexto.getText());
                    }
                }
            }
            else{//si no hay ningun modo 
                JOptionPane.showMessageDialog(null,"SELECCIONA UN MODO","Aviso",1);
            }
        }
    }                              
        
    public Image getImage(String im){return getImage(getDocumentBase(),im);}
    
}

